package com.dsic.gj_erp.bean.jcsj;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * <p>
 * 
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@TableName("DM_BCLQMXP")
@ApiModel(value="DmBclqmxp对象", description="")
public class DmBclqmxp implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "序号")
    @TableId(value = "XH", type = IdType.ASSIGN_UUID)
    private BigDecimal xh;

    @ApiModelProperty(value = "物品号(规格型材)")
    @TableField("WPH")
    private String wph;

    @ApiModelProperty(value = "材质(板材)")
    @TableField("WPXH")
    private String wpxh;

    @ApiModelProperty(value = "材质/规格(板材)")
    @TableField("WPGG")
    private String wpgg;

    @ApiModelProperty(value = "根数/板数(板材)")
    @TableField("SL")
    private BigDecimal sl;

    @ApiModelProperty(value = "领取重量")
    @TableField("LQZL")
    private BigDecimal lqzl;

    @ApiModelProperty(value = "实耗重量")
    @TableField("SHZL")
    private BigDecimal shzl;

    @ApiModelProperty(value = "余料重量")
    @TableField("YLZL")
    private BigDecimal ylzl;

    @ApiModelProperty(value = "前批余料代")
    @TableField("QPYLD")
    private BigDecimal qpyld;

    @ApiModelProperty(value = "长度(型材)")
    @TableField("YLZD11")
    private BigDecimal ylzd11;

    @ApiModelProperty(value = "领取米数(型材)")
    private BigDecimal lqms;

    @ApiModelProperty(value = "实耗米数(型材)")
    private BigDecimal shms;

    @ApiModelProperty(value = "名称(型材)")
    @TableField("WPMC")
    private String wpmc;

    @ApiModelProperty(value = "零件套料重量(板材)")
    @TableField("LJZL")
    private BigDecimal ljzl;

    @ApiModelProperty(value = "最近切割日期(板材)")
    private String qgrq;

    @ApiModelProperty(value = "切割数量(板材)")
    private BigDecimal qgsl;

    @ApiModelProperty(value = "领取类别")
    @TableField("LQLB_z")
    private String lqlbZ;

    @ApiModelProperty(value = "批量")
    @TableField("DC_PL_z")
    private String dcPlZ;

    @ApiModelProperty(value = "组立")
    @TableField("DC_ZL_z")
    private String dcZlZ;

    @ApiModelProperty(value = "船号")
    @TableField("DC_CH_z")
    private String dcChZ;

    @ApiModelProperty(value = "船名")
    @TableField("DC_CM_z")
    private String dcCmZ;

    @ApiModelProperty(value = "分段")
    @TableField("DC_FD_z")
    private String dcFdZ;

    @ApiModelProperty(value = "定额类型")
    @TableField("DELX_z")
    private String delxZ;

    @ApiModelProperty(value = "导入日期")
    @TableField("DERQ_z")
    private String derqZ;

    @ApiModelProperty(value = "项目编号")
    @TableField("XMBH_z")
    private String xmbhZ;

    @ApiModelProperty(value = "用板总数")
    @TableField("YBZS_z")
    private BigDecimal ybzsZ;

    @ApiModelProperty(value = "领取重量(总)")
    @TableField("LQZL_z")
    private BigDecimal lqzlZ;

    @ApiModelProperty(value = "实耗重量(总)")
    @TableField("SHZL_z")
    private BigDecimal shzlZ;

    @ApiModelProperty(value = "余料重量(总)")
    @TableField("YLZL_z")
    private BigDecimal ylzlZ;

    @ApiModelProperty(value = "前批余料代(总)")
    @TableField("QPYLD_z")
    private BigDecimal qpyldZ;

    @ApiModelProperty(value = "执行单位")
    @TableField("ZXDW_z")
    private String zxdwZ;

    @ApiModelProperty(value = "领取面积")
    @TableField("LQMJ_z")
    private BigDecimal lqmjZ;

    @ApiModelProperty(value = "车间底漆")
    @TableField("CJDQ_z")
    private BigDecimal cjdqZ;

    @ApiModelProperty(value = "稀料")
    @TableField("XL_z")
    private BigDecimal xlZ;

    @ApiModelProperty(value = "制单人")
    @TableField("ZDR_z")
    private String zdrZ;

    @ApiModelProperty(value = "制单日期")
    @TableField("ZDRQ_z")
    private String zdrqZ;

    @ApiModelProperty(value = "计算米数")
    @TableField("JSMS_z")
    private BigDecimal jsmsZ;

    @ApiModelProperty(value = "实耗米数(总)")
    @TableField("SHMS_z")
    private BigDecimal shmsZ;

    @ApiModelProperty(value = "零件套料重量")
    @TableField("LJZL_z")
    private BigDecimal ljzlZ;

    @ApiModelProperty(value = "加工跨")
    @TableField("ZZCJ_z")
    private String zzcjZ;

    @ApiModelProperty(value = "导入次数")
    private Integer drcs;

    @TableField("YLZD12")
    private BigDecimal ylzd12;

    @TableField("XGRQ")
    private String xgrq;

    @TableField("BZ_z")
    private String bzZ;

    @TableField("YLZD9")
    private String ylzd9;

    @TableField("YLZD10")
    private BigDecimal ylzd10;

    @TableField("BZ")
    private String bz;

    @TableField("YLZD7")
    private String ylzd7;

    @TableField("XGR")
    private String xgr;

    @TableField("YLZD8")
    private String ylzd8;

    private BigDecimal sysl;

    @TableField("LQBH")
    private String lqbh;

    @TableField(exist = false)
    private  BigDecimal dztlzl;
    @TableField(exist = false)
    private  BigDecimal tlshbl;


}
