package com.dsic.gj_erp.bean.jcsj;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.dsic.gj_erp.pc.dto.设备;
import com.dsic.gj_erp.pc.dto.资源;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * <p>
 * 
 * </p>
 *
 * @author xn
 * @since 2023-09-25
 */
@Data
@EqualsAndHashCode(callSuper = false)
@ApiModel(value="DmBom对象", description="")
public class DmBom implements Serializable {

    private static final long serialVersionUID=1L;

    @ApiModelProperty(value = "船号")
    private String dcch;

    @ApiModelProperty(value = "目标船号")
    private String mbch;

    @ApiModelProperty(value = "数据船号")
    private String sjch;

    @ApiModelProperty(value = "批量")
    private String pl;

    @ApiModelProperty(value = "分段")
    private String fd;

    @ApiModelProperty(value = "需求地点")
    private String xqdd;

    @ApiModelProperty(value = "抛丸")
    private String pw;

    @ApiModelProperty(value = "领取类别")
    private String lqlb;

    @ApiModelProperty(value = "跨位")
    private String kw;

    @ApiModelProperty(value = "设备编号")
    private String sbbh;

    @ApiModelProperty(value = "设备类型")
    private String sclx;

    @ApiModelProperty(value = "组立")
    private String zl;

    @ApiModelProperty(value = "物品材质")
    private String wpcz;

    @ApiModelProperty(value = "物品规格")
    private String wpgg;

    @ApiModelProperty(value = "板厚")
    private BigDecimal bh;

    @ApiModelProperty(value = "版长")
    private BigDecimal bc;

    @ApiModelProperty(value = "油漆用量")
    private BigDecimal yqyl;

    @ApiModelProperty(value = "切割长度")
    private BigDecimal qgcd;
    @ApiModelProperty(value = "实际切割长度")
    private BigDecimal fkqgcd;
    @ApiModelProperty(value = "划线长度")
    private BigDecimal hxcd;
    @ApiModelProperty(value = "实际划线长度")
    private BigDecimal fkhxcd;

    @ApiModelProperty(value = "图纸编号")
    private String tzbh;

    @ApiModelProperty(value = "套料数量")
    private BigDecimal tlsl;

    @ApiModelProperty(value = "坡口类型")
    private String pklx;

    @ApiModelProperty(value = "曲标识")
    private String qbs;

    @ApiModelProperty(value = "坡口标识")
    private String pkbs;

    @ApiModelProperty(value = "坡口长度")
    private BigDecimal pkcd;

    @ApiModelProperty(value = "打磨标识")
    private String dmbs;

    @ApiModelProperty(value = "打磨长度")
    private BigDecimal dmcd;

    @ApiModelProperty(value = "装配顺序")
    private Integer zpsx;

    @ApiModelProperty(value = "零件编号")
    private String ljbh;

    @ApiModelProperty(value = "零件数量")
    private BigDecimal ljsl;

    @ApiModelProperty(value = "零件属性")
    private String ljsx;

    @ApiModelProperty(value = "单件面积")
    private BigDecimal djmj;

    @ApiModelProperty(value = "零件单重")
    private BigDecimal ljdz;

    @ApiModelProperty(value = "备料")
    private BigDecimal blgs;

    @ApiModelProperty(value = "抛丸")
    private BigDecimal pwgs;

    @ApiModelProperty(value = "理料")
    private BigDecimal llgs;

    @ApiModelProperty(value = "划线")
    private BigDecimal hxgs;

    @ApiModelProperty(value = "切割")
    private BigDecimal qggs;

    @ApiModelProperty(value = "坡口")
    private BigDecimal pkgs;

    @ApiModelProperty(value = "曲")
    private BigDecimal qgs;

    @ApiModelProperty(value = "打磨")
    private BigDecimal dmgs;

    @ApiModelProperty(value = "装配")
    private BigDecimal zpgs;

    @ApiModelProperty(value = "反馈备料")
    private BigDecimal fkblgs;

    @ApiModelProperty(value = "抛丸")
    private BigDecimal fkpwgs;

    @ApiModelProperty(value = "理料")
    private BigDecimal fkllgs;

    @ApiModelProperty(value = "划线")
    private BigDecimal fkhxgs;

    @ApiModelProperty(value = "切割")
    private BigDecimal fkqggs;

    @ApiModelProperty(value = "坡口")
    private BigDecimal fkpkgs;

    @ApiModelProperty(value = "曲")
    private BigDecimal fkqgs;

    @ApiModelProperty(value = "打磨")
    private BigDecimal fkdmgs;

    @ApiModelProperty(value = "装配")
    private BigDecimal fkzpgs;

    private Integer pid;

    private String type;


    private Integer id;

    private String  fds;

    private String lqbs;

    private String tjbs;

    private String zt;

    private Integer cs;
    @TableId(value = "idd", type = IdType.ASSIGN_UUID)
    private String  idd;


    private String yidd;
    private String bzry;
    private String bzrq;

    // 型材根数
    private BigDecimal xcgs;
    //型材实耗米数
    private BigDecimal xcshms;

    private BigDecimal  bclqzl;
    private BigDecimal  bcshzl;
    private BigDecimal  bcylzl;
    private BigDecimal  bcljtlzl;
    private BigDecimal  bcqpyld;
    private String   ylbhgg;


    // 反馈工时
    private String  fkgs;

    @TableField(exist = false)
    private 资源 所在资源;

    @TableField(exist = false)
    private 设备 所在设备;

}
