package com.dsic.gj_erp.bean.txzz.jhgl;

import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.annotation.ExcelProperty;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.Setter;

import java.util.Arrays;
import java.util.List;

@Getter
@Setter
@TableName("dm_tpbh_plan")
public class TpbhPlan {
    @TableId(type = IdType.ASSIGN_UUID)
    private String id;//
    @ExcelProperty("工程编号")
    private String project;//工程编号 Q11 ERP=czbh

    @ExcelProperty("区域")
    private String zone;//区域   Q12 ERP=qy

    @ExcelProperty("分段号")
    private String blockNo;//分段号 暂不显示 ERP=fdh

    @ExcelProperty("批号")
    private String ph;//批号 Q21 ERP=ph

    private String lckNo;//流程卡号 Q22 ERP=bh
    private String planType;//计划类型 ERP=rwlx dict=‘ZYJHLX’ (作业计划类型  参考erp xtbm='rwjd')
    private String scType;//施工类型 ERP=jglx dict=‘JGLX’ (施工类型  参考erp xtbm='jglx')
    private String status;//计划状态 ERP=jhlx Q15 dict=‘ZYJHZT’ (作业计划状态 01-编制 02-下达) 默认01
    private String kh;//卡号 ERP=kh 默认=批号  暂不显示

    @ExcelProperty("托盘表号")
    private String pmlNo;//托盘表号 ERP=tpbh 暂不使用
    private String sscj;//所属车间 ERP=sscj 不用显示，关联制作图数据使用  默认赋值(02-管子 021-管支架)

    @ExcelProperty("责任单位")
    private String departCode;//责任单位  (默认查询限制 02-管系制造部)

    @ExcelProperty("图纸类型")
    private String dwgType;//图纸类型  Q25 ERP=xz dict='TZLX' (01-制作图 02-通知单 99-其他)

    @ExcelProperty("制作图号")
    private String dwgNo;//制作图号 ERP=zzth 暂不使用 铁舾使用

    @ExcelProperty("部件代号")
    private String itemNo;//部件代号 ERP=bjbh 暂不使用 铁舾使用

    @ExcelProperty("部件名称")
    private String itemName;//部件名称 ERP=bjmc 暂不使用 铁舾使用

    @ExcelProperty("修正部件代号")
    private String itemNo1;//部件代号 ERP=gysbh 暂不使用 铁舾使用(工艺识别号、修正部件代号)

    @ExcelProperty("部件序号")
    private String itemXh;//部件序号 ERP=bjxh 暂不使用 铁舾使用

    @ExcelProperty("部件数量")
    private String itemQty;//部件数量 ERP=gs
    private String wkhour;//工时 ERP=jggs

    @ExcelProperty("部件重量")
    private String itemWgt;//总重量(KG) ERP=zzl
    private String gcWgt;//管材重量(Kg) ERP=ds
    private String fjWgt;//附件重量(KG) ERP=fjzl
    private String hcWgt;//焊材重量(KG) ERP=hczl
    private String gcInArea;//管材内表面积(㎡) ERP=gcnbmj
    private String gcOutArea;//管材外表面积(㎡) ERP=gcwbmj

    @ExcelProperty("内涂装面积")
    private String itemInArea;//部件内表面积(㎡) (铁舾使用)

    @ExcelProperty("外涂装面积")
    private String itemOutArea;//部件外表面积(㎡) (铁舾使用)

    @ExcelProperty("留焊区域")
    private String itemLhArea;//留焊区域(㎡)* (铁舾使用)
    private String hdsl;//焊点数 ERP=hdsl
    private String zgsl;//支管数 ERP=zgsl
    private String wqsl;//弯曲数 ERP=wqsl
    private String pksl;//坡口翻边压槽数 ERP=pksl
    private String itemShape;//管型 ERP=gzlx
    private String itemType;//类型 ERP=bjlx

    @ExcelProperty("产品类型")
    private String prodType;//产品类型* ERP=cplx  (铁舾使用)

    @ExcelProperty("材质")
    private String itemGrd;//材质 ERP=bjcz

    @ExcelProperty("部件规格")
    private String itemSpec;//规格 (规格范围) ERP=bjgg
    private String jyyq;//探伤要求 ERP=jyyq
    private String bybs;//磅压要求 ERP=bybs
    private String jybs;//报验要求 ERP=jybs
    private String tsbs;//探伤标识 ERP=tsbs

    @ExcelProperty("处理方式")
    private String treatmentType;//处理方式 ERP=tzfs
    private String treatment;//表面处理 ERP=nbmcl
    private String paintCode;//涂装代码 ERP=tzdm
    private String inTreatment;//内表面处理 (暂不使用)

    @ExcelProperty("内涂装代码")
    private String inPaintCode;//内涂装代码 (暂不使用)
    private String outTreatment;//外表面处理 (暂不使用) ERP=wbmcl

    @ExcelProperty("外涂装代码")
    private String outPaintCode;//外涂装代码 (暂不使用)
    private String wkhourXl;//下料工时  ERP=C0201
    private String wkhourWq;//弯曲工时  ERP=C0202
    private String wkhourPt;//平台工时  ERP=C0203
    private String wkhourHj;//焊接工时  ERP=C0204
    private String wkhourQl;//清理工时  ERP=C0205
    private String wkhourWg;//外观工时  ERP=C0206
    private String wkhourBy;//磅压工时  ERP=C0207
    private String wkhourZy;//转运工时  ERP=C0208

    @ExcelProperty("制作单位")
    private String scDept;//制作单位 ERP=sgdw  (下拉选择  dmDepart 中parentCode='02' and  制作标识的 departCode )

    @ExcelProperty("镀锌单位")
    private String clDept;//表面处理单位 ERP=bmcldw (下拉选择  dmDepart 中 parentCode='02' and 处理标识的 departCode )
    private String nclDept;//内表面处理单位 ERP=nbmcldw (下拉选择  dmDepart 中 parentCode='02' and 处理标识的 departCode )

    @ExcelProperty("涂装单位")
    private String tzDept;//涂装单位  (下拉选择  dmDepart 中 parentCode='02' and 处理标识的 departCode )

    @ExcelProperty("配送单位")
    private String psDept;//配送单位  ERP=psdw(下拉选择  dmDepart 中 parentCode='02' and 配送标识的 departCode )
    private String gcdhrq;//管材到货日期* (暂不使用)
    private String fjdhrq;//附件到货日期* (暂不使用)
    private String jlry;//建立人员 ERP原来没有 生成作业计划时的流程卡审核人员
    private String jlrq;//建立日期 ERP=jlrq  生成作业计划时的流程卡审核日期
    private String csry;//测算人员 ERP=sgbz
    private String cssj;//测算时间 ERP=sgbz
    private String csfk;//测算下达标识* ERP=sfxd (是否下达，暂不使用)
    private String fkrq;//发卡日期 ERP=fkrq
    private String jhrqZzwg;//制作计划完工日期 ERP=jsrq
    private String jhrqZzwg0;//初始计划完工日期 ERP=zyjhblwcsj
    private String jhrqNclwg;//内处理完工计划日期
    private String jhrqClwg;//处理完工计划日期
    private String jhrqTzwg;//涂装完工计划日期* (暂不使用)
    private String jhrqJpwg;//集配完工计划日期* (暂不使用)
    private String xdry;//计划下达人员
    private String xdrq;//计划下达日期
    private String scjd;//生产进度  ERP=scjd
    private String wgbs;//制作完工标识 ERP=wgbs   默认’‘/'完工'
    private String wgrq;//制作完工日期 ERP=wgrq
    private String xgStaus;//修改状态 ERP=zrr  默认''/'部分修改'/'整卡取消'
    private String scStatus;//制作状态 ERP=zzzt  dict='GXZZZT'  管系制作状态 ERP zhbmp=’HBZT‘

    @ExcelProperty("备注")
    private String remark;//备注 ERP=bz
    private String scRemark;//作业区制作情况说明 ERP=wbmcl
    private String scRemark0;//作业区上次反馈情况 ERP=ppfkrq
    private String bzph;//班组制作批号 ERP=bzph
    private String xlgw;//下料工位 ERP=xlgw
    private String xljhrq;//下料计划日期 ERP=xljhrq
    private String ptgw;//平台工位  ERP=ptgw
    private String ptjhrq;//平台计划日期  ERP=ptjhrq
    private String bzjhStatus;//班组计划状态  ERP=bzjhzt dict=‘BZJHZT’ (班组计划状态 01-编制 02-审核)
    private String bzjhBzry;//班组计划编制人员 ERP=bzjhbzr
    private String bzjhBzrq;//班组计划编制日期 ERP=bzjhbzq
    private String bzjhShry;//班组计划审核人员 ERP=无
    private String bzjhShrq;//班组计划审核日期 ERP=无
    private String gclldh;//管材领料单号 ERP=lldh
    private String fjlldh;//附件领料单号 ERP=fjlldh
    private String lldbzry;//领料单编制人员 ERP=lldbzr
    private String lldbzrq;//领料单编制日期 ERP=lldbzrq
    private String hclldh;//焊材领料单号 ERP=hclldh
    private String hclldbzry;//焊材领料单编制人员 ERP=hclldbzr
    private String hclldbzrq;//焊材领料单编制日期 ERP=hclldbzrq
    private String scryXl;//下料人员 ERP=xlry
    private String scryWq;//弯曲人员 ERP=wqry
    private String scryPt;//平台人员 ERP=ptry
    private String scryHj;//焊接人员 ERP=hjry
    private String scryQl;//清理人员 ERP=qlry
    private String scryWg;//外观人员 ERP=wgry
    private String scryBy;//磅压人员 ERP=byry
    private String scryZy;//转运人员 ERP=zyry
    private String aqfzXl;//下料安全责任人 ERP=xlaq
    private String aqfzWq;//弯曲安全责任人 ERP=wqaq
    private String aqfzPt;//平台安全责任人 ERP=ptaq
    private String aqfzHj;//焊接安全责任人 ERP=hjaq
    private String aqfzQl;//清理安全责任人 ERP=qlaq
    private String aqfzWg;//外观安全责任人 ERP=wgaq
    private String aqfzBy;//磅压安全责任人 ERP=byaq
    private String aqfzZy;//转运安全责任人 ERP=zyaq
    private String scFzry;//作业区长 ERP=bmry
    private String wkhourXl1;//班组下料工时  ERP=D0201
    private String wkhourWq1;//班组弯曲工时  ERP=D0202
    private String wkhourPt1;//班组平台工时  ERP=D0203
    private String wkhourHj1;//班组焊接工时  ERP=D0204
    private String wkhourQl1;//班组清理工时  ERP=D0205
    private String wkhourWg1;//班组外观工时  ERP=D0206
    private String wkhourBy1;//班组磅压工时  ERP=D0207
    private String wkhourZy1;//班组转运工时  ERP=D0208
    private String backDate;//反卡日期
    private String backMonth;//反卡月份
    private String backRemark;//发卡备注

    @ExcelProperty("前方需求日期")
    private String qfxqrq;//前方需求日期2021116
    private String jhrqZzwg1;//结构计划调整日期2021116
    private String jhrqTzwg1;//涂装计划调整日期2021116
    private String jhrqBlrq;//备料计划日期2021116

    @ExcelProperty("机加计划日期")
    private String jhrqJjrq;//机加计划日期2021116
    private String jhrqClwg1;//镀锌计划调整日期2021116
    private String jlrid;//建立人员ID2021116
    private String csrid;//测算人员ID2021116
    private String xdrid;//下达人员ID2021116
    private String spry;//审批人员2021116
    private String sprq;//审批日期2021116
    private String sprid;//审批人ID2021116

    @ExcelProperty("结构计划期")
    private String jhrq;//结构计划日期2021116

    @ExcelProperty("镀锌计划期")
    private String dxrq;//镀锌计划日期2021116

    @ExcelProperty("涂装计划日期")
    private String tzrq;//涂装计划日期2021116

    @ExcelProperty("入库计划期")
    private String rkrq;//入库计划日期2021116
    private String wgJhrq;//结构实际完工日期2021116
    private String wgDxrq;//镀锌实际完工日期2021116
    private String wgTzrq;//涂装实际完工日期2021116
    private String wgRkrq;//入库实际完工日期2021116
    private String jgzySl;//结构转运数量2021116
    private String jgzyRy;//结构转运人员2021116
    private String jgzyCh;//结构转运车号2021116
    private String jgzyRq;//结构转运日期2021116
    private String jgzyLsh;//结构转运单号2021116
    private String dxzySl;//镀锌转运数量2021116
    private String dxzyRy;//镀锌转运人员2021116
    private String dxzyCh;//镀锌转运车号2021116
    private String dxzyRq;//镀锌转运日期2021116
    private String dxzyLsh;//镀锌转运单号2021116
    private String tzzySl;//涂装转运数量2021116
    private String tzzyRy;//涂装转运人员2021116
    private String tzzyCh;//涂装转运车号2021116
    private String tzzyRq;//涂装转运日期2021116
    private String tzzyLsh;//结构转运单号2021116

    //todo 缺少字段
    @ExcelProperty("需求单位")
    @TableField(exist = false)
    private String ddepartCode;

    @TableField(exist = false)
    private boolean repeat;//是否重复提取

    /**
     * 导入时,数据校验
     */
    public boolean checkBaseParam(){
        if (ObjectUtil.isEmpty(this.getProject())){
            throw new RuntimeException("工程编号不能为空");
        }
        if (ObjectUtil.isEmpty(this.getDwgNo())){
            throw new RuntimeException("制作图号不能为空");
        }
        if (ObjectUtil.isEmpty(this.getPmlNo())){
            throw new RuntimeException("托盘表号不能为空");
        }
        if (ObjectUtil.isEmpty(this.getItemNo())){
            throw new RuntimeException("部件代号不能为空");
        }
        if (ObjectUtil.isEmpty(this.getItemName())){
            throw new RuntimeException("部件名称不能为空");
        }
        if (ObjectUtil.isEmpty(this.getItemSpec())){
            throw new RuntimeException("部件规格不能为空");
        }
        return true;
    }

    /**
     * 变更为提交状态
     */
    public void fixToSubmitStatus(){
        this.status=StatusEnum.下达.code;
    }

    /**
     * 变更为审核状态
     */
    public void fixToShStatus(){
        this.status=StatusEnum.生产.code;
    }

    /**
     * 变更为提交状态
     */
    public void fixToSpStatus(){
        this.status=StatusEnum.运转.code;
    }

    @AllArgsConstructor
    public enum StatusEnum{
        编制("01"),
        下达("02"),
        生产("03"),
        运转("04"),
        完工("05"),
        入库("06");
        @Getter
        private String code;
    }

    public void updateForSubmit(String userName, String userCode, String data){
        this.fixToSubmitStatus();
        this.setCsry(userName);
        this.setCssj(data);
        this.setCsrid(userCode);
    }

    public void updateForSh(String userName, String userCode, String data){
        this.fixToShStatus();
        this.setXdry(userName);
        this.setXdrq(data);
        this.setXdrid(userCode);
    }

    public void updateForSp(String userName, String userCode, String data){
        this.fixToSpStatus();
        this.setSpry(userName);
        this.setSprq(data);
        this.setSprid(userCode);
    }

    //保存时,提交时,结构计划期、涂装计划期、入库计划期不能为空
    public boolean canSave(){
        checkBaseParam();
        if (!this.status.equals("01")){
            return false;
        }
        if (StrUtil.isEmpty(this.jhrq)){
            throw new RuntimeException("结构计划期为空");
        }
        if (StrUtil.isEmpty(this.tzrq)){
            throw new RuntimeException("涂装计划期为空");
        }
        if (StrUtil.isEmpty(this.rkrq)){
            throw new RuntimeException("入库计划期为空");
        }
        if (StrUtil.isEmpty(this.treatmentType)){
            throw new RuntimeException("处理方式为空");
        }
        if (dxTreatmentTypeList.contains(this.treatmentType)&&StrUtil.isEmpty(this.dxrq)){
            throw new RuntimeException("镀锌计划期为空");
        }
        return this.repeat;
    }

    public boolean canSubmit(){
        return this.status.equals("01");
    }

    public boolean equals(TpbhPlan plan){
        return ObjectUtil.isNotEmpty(plan)&&this.getProject().equals(plan.getProject())
                &&this.getDwgNo().equals(plan.getDwgNo())
                &&this.getDepartCode().equals(plan.getDepartCode())
                &&this.getItemNo().equals(plan.getItemNo())
                &&this.getPmlNo().equals(plan.getPmlNo());
    }

    //镀锌
    public static List<String> dxTreatmentTypeList= Arrays.asList("01","02","04","05");
}
