package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jhgk.DmYdjhLj;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.jhgk.DmYdjhLjService;
import com.dsic.gj_erp.service.pgd.PgdPkjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdPkjh")
public class PgdPkjhController {
    @Autowired
    PgdPkjhService  pgdPkjhService;

    @Autowired
    DmYdjhLjService dmYdjhLjService;



    @PostMapping("/getPkPgd")
    @ResponseBody
    public ResultBean getPkPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<DmYdjhLj> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"pk_zt",(String)map.get("zt"));

        qw.eq("pkbs","Y");
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(dmYdjhLjService.list(qw));

    }

    @PostMapping("/savePkPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean savePkPgdXd(HttpServletRequest req, @RequestBody List<DmYdjhLj> list) throws Exception, CustomException {
        pgdPkjhService.savePkPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/savePkPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean savePkPgdXdBack(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdPkjhService.savePkPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/savePkPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean savePkPgdFk(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdPkjhService.savePkPgdFk(list,req); ;
        return new ResultBean();
    }

    @PostMapping("/savePkFk")
    @ResponseBody
    @AuthFunction
    public ResultBean savePkFk(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdPkjhService.savePkFk(list,req);
        return new ResultBean();
    }
    @PostMapping("/savePkPgdJs")
    @ResponseBody
    @AuthFunction
    public ResultBean savePkPgdJs(HttpServletRequest req, @RequestBody List<DmYdjhLj>list) throws Exception, CustomException {
        pgdPkjhService.savePkPgdJs(list,req);
        return new ResultBean();
    }

}

