package com.dsic.gj_erp.pc;

import cn.hutool.core.date.DateField;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjUtil;
import cn.hutool.core.util.StrUtil;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.dsic.gj_erp.bean.SpringContextHolder;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jcsj.EmSbjbb;
import com.dsic.gj_erp.bean.jhgk.DmSygdxq;
import com.dsic.gj_erp.bean.jhgk.DmZrcjh;
import com.dsic.gj_erp.exception.ServiceException;
import com.dsic.gj_erp.pc.dto.data.Bom;
import com.dsic.gj_erp.pc.dto.data.钢料需求;
import com.dsic.gj_erp.pc.dto.gx.*;
import com.dsic.gj_erp.pc.dto.sb.*;
import com.dsic.gj_erp.pc.dto.tlt.*;
import com.dsic.gj_erp.pc.dto.套料图工序;
import com.dsic.gj_erp.pc.dto.工序产能;
import com.dsic.gj_erp.pc.dto.设备;
import com.dsic.gj_erp.pc.dto.资源;
import com.dsic.gj_erp.pc.service.工序CD接口;
import com.dsic.gj_erp.pc.service.订货计划滚动信息接口;
import com.dsic.gj_erp.pc.service.设备产能接口;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import com.dsic.gj_erp.service.jcsj.EmSbjbbService;
import com.dsic.gj_erp.service.jhgk.DmSygdxqService;
import com.dsic.gj_erp.service.jhgk.DmZrcjhService;
import com.google.common.collect.ImmutableMap;
import com.google.common.util.concurrent.AtomicDouble;
import lombok.extern.slf4j.Slf4j;

import java.io.FileOutputStream;
import java.io.OutputStream;
import java.util.*;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicReference;
import java.util.stream.Collectors;

import static com.dsic.gj_erp.pc.Manager.*;

@Slf4j
public class DataFactory {

    private static DmZrcjh 获取中日程(String key){
        return getBean(DmZrcjhService.class).排产获取中日程数据(key);
    }
    private static void 装载中日程数据(){
        getBean(DmZrcjhService.class).排产中日程数据加载();
    }

    private static void 清理冗余数据(List<钢料需求> list){

        list.forEach(钢料需求->{
            钢料需求.getBomList().forEach(bom -> {
                if (bom.get所在设备()!=null){
                    bom.set所在设备(null);
                }
                if (bom.get所在资源()!=null){
                    bom.set所在资源(null);
                }
            });
        });
    }

    public static void 排产4(){
        装载中日程数据();
        套料图所占工序的资源.clear();
        Manager.排产结果=new ArrayList<>();

        List<钢料需求> list=读取钢料需求1();
        List<钢料需求> 按批次合并 = 合并批次(list);

        try {
            均衡预占(按批次合并);
        }catch (Exception e){
            e.printStackTrace();
            throw new ServiceException(10001,"排产结果异常");
        }finally {
            清理冗余数据(list);
        }

    }

    public static void 均衡预占(List<钢料需求> list){
        工序CD接口 _工序CD接口 = getBean(工序CD接口.class);
        List<工序CD> 工序CDS = _工序CD接口.get();
        Map<Constant.工序,工序CD> 工序CDMap=new HashMap<>();
        工序CDS.forEach(item->工序CDMap.put(item.getGx(),item));

        for (钢料需求 item:list){
            if (ObjUtil.isNotEmpty(item.getBomList())){
                均衡计算(item,工序CDMap);
            }
        }
    }

    private static void 均衡计算(钢料需求 item,Map<Constant.工序,工序CD> 工序CDMap){
        Constant.工序 依据工序=Constant.工序.切割;
        //需求日期可利用范围是±3天
        int times=-3;
        List<资源> tmpList=new ArrayList<>();
        Map<String, AtomicDouble> 切割各设备需求量 = item.get切割各设备需求量();
        资源 _资源=null;
        Integer cd = 工序CDMap.get(依据工序).getCd();
        do {
            //因为第一次计算时候就是当前批量小组需求日期,所以再次循环到的时候不需要再次计算
            if (times==0){
                times+=1;
                item.set均衡需求日期(DateUtil.offsetDay(DateUtil.parse(item.getXzglxq(),"yyyy/MM/dd"),times));
                continue;
            }
            if (times>3){
                break;
            }

            DateTime xzglxq = item.get均衡需求日期().offset(DateField.DAY_OF_YEAR,cd);

            if (xzglxq.isBefore(DateUtil.date())){
                //break;
            }

            _资源 = 提取资源(xzglxq);
            if (_资源.get_date().isBefore(DateUtil.date())){
                //break;
            }
            //记录6次计算的全部资源
            tmpList.add(_资源);
            if (_资源.判断切割设备是否可以被占用(切割各设备需求量)){
                执行排产(item.getBomList(),item.get均衡需求日期(),工序CDMap);
                break;
            }
            //需求日期可利用范围是±3天,排产是需要根据产能进行调整
            item.set均衡需求日期(DateUtil.offsetDay(DateUtil.parse(item.getXzglxq(),"yyyy/MM/dd"),times));
            times+=1;
        }while (true);

        //若在需求期±3天内无法正常排产时,查找最大可用空闲资源进行占用
        AtomicReference<String> date=new AtomicReference<>();
        if (times>3){
            //查找最小可用资源,进行占用
            tmpList.sort(Comparator.comparingDouble((tmp)->tmp.get工序产能MAP().get(Constant.工序.切割).get占用()));
            tmpList.stream().findFirst().ifPresent(tmp->{
                DateTime offset = DateUtil.parse(tmp.getDate()).offset(DateField.DAY_OF_MONTH, -工序CDMap.get(依据工序).getCd());
                执行排产(item.getBomList(),offset,工序CDMap);
                date.set(tmp.getDate());
            });
        }
        if (_资源!=null){
            date.set(_资源.getDate());
        }else {
            log.info("船号:{},批次:{},早于当前日期无需排产",item.getDcCh(),item.getDcPl());
            return;
        }
        log.info("船号:{},批次:{},占用资源成功,切割日期:{}",item.getDcCh(),item.getDcPl(),date.get());
    }

    private static void 执行排产(List<Bom> list,DateTime 参照需求日期,Map<Constant.工序,工序CD> 工序CDMap){
        CountDownLatch latch = new CountDownLatch(list.size());
        for (Bom bom:list){
            套料图工序 _套料图工序 = 套料图工序工厂(bom);

            if (_套料图工序==null){
                latch.countDown();
                log.info("船号:{},批次:{},图纸编号:{},无法找到对应套料图",bom.getDcch(),bom.getPl(),bom.getTzbh());
                continue;
            }

            _套料图工序.setXzglxq(bom.getXzglxq());
            _套料图工序.setDzglxq(bom.getDzglxq());
            _套料图工序.set工序CD(工序CDMap);
            _套料图工序.set中日程(获取中日程(bom.getDcch() + bom.getPl() + bom.getFd()));
            _套料图工序.set参照需求日期(参照需求日期);
            es.execute(() -> {
                try{
                    _套料图工序.run();
                }finally {
                    latch.countDown();
                }
            });
        }
        try {
            latch.await(30, TimeUnit.SECONDS);// 指定超时时间
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    private static List<钢料需求> 合并批次(List<钢料需求> list){
        Map<String,钢料需求> map=new HashMap<>();
        list.forEach(item->{
            String key=item.getDcCh() + item.getDcPl();
            钢料需求 _钢料需求 = map.get(key);
            if (_钢料需求==null){
                map.put(key,item);
            }else{
                _钢料需求.addBomList(item.getBomList());
            }
        });
        return new ArrayList<>(map.values());
    }

    public static List<钢料需求> 读取钢料需求1(){
        List<DmSygdxq> 按需求日期排序的钢料需求 = getBean(DmSygdxqService.class).getXqWithBom(from, to);
        return 按需求日期排序的钢料需求.stream().map(item->{
            钢料需求 _钢料需求 = 钢料需求.of(item);
            _钢料需求.计算各设备切割需求量();
            return _钢料需求;
        }).collect(Collectors.toList());
    }

    private static Map<String,List<订货计划>> _订货计划=new HashMap<>();
    public static List<订货计划> 获取订货计划(String dcch){
        List<订货计划> list=_订货计划.get(dcch);
        if (list!=null){
            return list;
        }
        List<订货计划> _订货计划 = getBean(订货计划滚动信息接口.class).get();
        Map<String,List<订货计划>> map= _订货计划.stream().collect(Collectors.groupingBy(订货计划::getDcch));
        return map.get(dcch);
    }

    public static 资源 提取资源(Date date){
        资源 资源 = 资源池.get(DateUtil.format(date, "yyyy/MM/dd"));
        if (资源==null){
            return 提取资源(DateUtil.offsetDay(date,-1));
        }
        return 资源;
    }

    public static Map<Constant.工序, 工序产能> 计算日产能(){
        Map<Constant.工序, 工序产能> map = new HashMap<>();
        Arrays.stream(Constant.工序.values()).forEach(_item -> {
            if (StrUtil.isNotEmpty(_item.getCode())) {
                工序产能 工序产能 = 工序产能工厂(_item);
                if (工序产能!=null){
                    map.put(_item, 工序产能);
                }
            }
        });
        return map;
    }

    public static void 创建产能资源池(){
        资源池.clear();
        DateTime _from = DateUtil.parse(from, "yyyy/MM/dd").offset(DateField.DAY_OF_YEAR,-30);
        DateTime _to = DateUtil.parse(to, "yyyy/MM/dd");
        工厂日历.stream().filter(item -> "1".equals(item.getXxr()))
                .filter(item->{
                    DateTime gl = DateUtil.parse(item.getGl(), "yyyy/MM/dd");
                    return gl.isAfterOrEquals(_from)&&gl.isBeforeOrEquals(_to);
                })
                .forEach(item -> {
                    Map<Constant.工序, 工序产能> map = 计算日产能();
                    资源池.put(item.getGl(), 资源.of(item.getGl(), map));
                });
    }

    public static 套料图工序 套料图工序工厂(Bom bom) {
        switch (bom.getKw() + bom.getZl()) {
            case "51010":
                return new 二跨T型材面板().小组(bom);
            case "51110":
                return new 二跨T型材面板().大组(bom);
            case "61010":
                return new 三跨平铁().小组(bom);
            case "61110":
                return new 三跨平铁().大组(bom);
            case "64230":
                return new 三跨平铁().焊接机器人肘板(bom);
            case "71010":
                return new 一跨平直大板().小组(bom);
            case "71110":
                return new 一跨平直大板().大组(bom);
            case "81110":
                return new 一跨进线板().大组(bom);
            case "91010":
                return new 二跨超长超宽板().小组(bom);
            case "91110":
                return new 二跨超长超宽板().大组(bom);
            case "101010":
                return new 二跨超长超宽曲板().小组(bom);
            case "101110":
                return new 二跨超长超宽曲板().大组(bom);
            case "111010":
                return new 二跨T型材腹板().小组(bom);
            case "111110":
                return new 二跨T型材腹板().大组(bom);
            case "121010":
                return new 二跨激光切割板().小组(bom);
            case "121110":
                return new 二跨激光切割板().大组(bom);
            case "131010":
                return new 三跨曲板().小组(bom);
            case "131110":
                return new 三跨曲板().大组(bom);
            case "141010":
                return new 三跨厚板().小组(bom);
            case "141110":
                return new 三跨厚板().大组(bom);
            case "151010":
                return new 四跨普通板().小组(bom);
            case "151110":
                return new 四跨普通板().大组(bom);
            case "154230":
                return new 四跨普通板().焊接机器人肘板(bom);
            case "161010":
                return new 七跨型板().小组(bom);
            case "161110":
                return new 七跨型板().大组(bom);
            case "171120":
                return new 光电().小组(bom);
            default:
                return null;
        }
    }

    public static 工序产能 工序产能工厂(Constant.工序 _工序) {
        设备产能接口 _设备产能接口 = getBean(设备产能接口.class);
        List<设备产能> 设备产能 = _设备产能接口.get();
        Map<String, 设备> _设备;
        ImmutableMap.Builder<String, 设备> builder = ImmutableMap.builder();
        switch (_工序) {
            case 上料:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备01上料(item)));
                _设备 = builder.build();
                return new 工序01上料(_设备);
            case 抛丸:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备02抛丸(item)));
                _设备 = builder.build();
                return new 工序02抛丸(_设备);
            case 理料:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备03理料(item)));
                _设备 = builder.build();
                return new 工序03理料(_设备);
            case 划线:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备04划线(item)));
                _设备 = builder.build();
                return new 工序04划线(_设备);
            case 切割:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备05切割(item)));
                _设备 = builder.build();
                return new 工序05切割(_设备);
            case 坡口:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备07坡口(item)));
                _设备 = builder.build();
                return new 工序07坡口(_设备);
            case 型材面板:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备10型材(item)));
                _设备 = builder.build();
                return new 工序10型材(_设备);
            case 曲型:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备08曲面(item)));
                _设备 = builder.build();
                return new 工序08曲面(_设备);
            case 打磨:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备09打磨(item)));
                _设备 = builder.build();
                return new 工序09打磨(_设备);
            case 自由边处理:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备21自由边处理(item)));
                _设备 = builder.build();
                return new 工序21自由边处理(_设备);
            case 光电结束:
                设备产能.stream().filter(item->item.get_工序()==_工序).forEach(item->builder.put(item.getCode(),new 设备31光电(item)));
                _设备 = builder.build();
                return new 工序31光电(_设备);
//            case 预配盘:
//                return new 工序01上料(_工序,_设备);
//            case 配送:
//                return new 工序01上料(_工序,_设备);
            default:
                return null;
        }
    }

    public static void 加载工厂日历(){
        List<EmGcrl> list = getBean(EmGcrlService.class).getList(new JSONObject());
        工厂日历.clear();
        工厂日历.addAll(list);
    }

    public static void 加载套料图工序对应关系(){
        套料图工序对应关系.clear();
        List<EmSbcnp> list = getBean(EmSbcnpService.class).list();
        Map<String, List<EmSbcnp>> map = list.stream().collect(Collectors.groupingBy(l -> l.getTzbh() + l.getZl()+"_"+l.getGx()));
        map.keySet().forEach(key->{
            String gxCode=key.split("_")[1];
            套料图工序对应关系.put(key,Constant.工序.getGxByCode(gxCode));
        });
    }

    public static void 加载设备信息(){
        List<EmSbjbb> deviceList = getBean(EmSbjbbService.class).list(Wrappers.<EmSbjbb>lambdaQuery().like(EmSbjbb::getScbs, "1"));
        设备列表.clear();
        设备列表.addAll(deviceList);
    }

    public static void 输出排产结果到EXCEL(OutputStream stream){

    }


    public static void 输出排产结果到EXCEL(String fileName){
        try(FileOutputStream fos=new FileOutputStream(fileName)) {
            输出排产结果到EXCEL(fos);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private static <T> T getBean(Class<T> clazz) {
        return SpringContextHolder.getBean(clazz);
    }
    private DataFactory(){}
}
